//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C62B2170294.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C62B2170294.cm

//## begin module%3C62B2170294.cp preserve=no
//## end module%3C62B2170294.cp

//## Module: MixComponent%3C62B2170294; Package body
//## Subsystem: XSModel::Model::Component%367691A33718
//	/local/data/verisB/dorman/Xspec/src/component
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/MixComponent.cxx

//## begin module%3C62B2170294.additionalIncludes preserve=no
//## end module%3C62B2170294.additionalIncludes

//## begin module%3C62B2170294.includes preserve=yes
//## end module%3C62B2170294.includes

// ComponentBase
#include <XSModel/Model/Component/ComponentBase.h>
// MixComponent
#include <XSModel/Model/Component/MixComponent.h>
//## begin module%3C62B2170294.declarations preserve=no
//## end module%3C62B2170294.declarations

//## begin module%3C62B2170294.additionalDeclarations preserve=yes
#include <XSstreams.h>
#include <XSUtil/FunctionUtils/XSModelFunction.h>
#include <XSModel/Model/Component/MixBase.h>
#include <XSModel/Model/Component/CGroupBase.h>
#include <typeinfo>
#include <memory>
//## end module%3C62B2170294.additionalDeclarations


// Class MixComponent 

MixComponent::MixComponent(const MixComponent &right)
  //## begin MixComponent::MixComponent%362809DF00E6_copy.hasinit preserve=yes
  : Component(right)
  //## end MixComponent::MixComponent%362809DF00E6_copy.hasinit
  //## begin MixComponent::MixComponent%362809DF00E6_copy.initialization preserve=yes
  //## end MixComponent::MixComponent%362809DF00E6_copy.initialization
{
  //## begin MixComponent::MixComponent%362809DF00E6_copy.body preserve=yes
  cloneParameters(*this,right);
  //## end MixComponent::MixComponent%362809DF00E6_copy.body
}

MixComponent::MixComponent (CGroupBase* p)
  //## begin MixComponent::MixComponent%37EF90AE0538.hasinit preserve=yes
     : Component(p)
  //## end MixComponent::MixComponent%37EF90AE0538.hasinit
  //## begin MixComponent::MixComponent%37EF90AE0538.initialization preserve=yes
  //## end MixComponent::MixComponent%37EF90AE0538.initialization
{
  //## begin MixComponent::MixComponent%37EF90AE0538.body preserve=yes
  //## end MixComponent::MixComponent%37EF90AE0538.body
}


MixComponent::~MixComponent()
{
  //## begin MixComponent::~MixComponent%362809DF00E6_dest.body preserve=yes
  componentBase()->deleteParameters(); 
  //## end MixComponent::~MixComponent%362809DF00E6_dest.body
}



//## Other Operations (implementation)
MixComponent* MixComponent::clone (CGroupBase* p) const
{
  //## begin MixComponent::clone%38E3B862A0D8.body preserve=yes
  MixComponent* cloned = new MixComponent(*this);
  cloned->setParent(p);
  return cloned;    
  //## end MixComponent::clone%38E3B862A0D8.body
}

void MixComponent::copy (const Component& right)
{
  //## begin MixComponent::copy%3A953EB90011.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  MixComponent __temp(static_cast<const MixComponent&>(right));
  swap(__temp);    
  //## end MixComponent::copy%3A953EB90011.body
}

void MixComponent::calculate (bool saveComponentFlux, bool frozen)
{
  //## begin MixComponent::calculate%3AD2290F004B.body preserve=yes
  if (saveComponentFlux) saveUniquePhotonArray(saveComponentFlux);
  
 
  // do nothing else. calculate at the 'multiply' stage.      
        
  //## end MixComponent::calculate%3AD2290F004B.body
}

void MixComponent::initialize ()
{
  //## begin MixComponent::initialize%3F9D5A6B02AD.body preserve=yes
  // initialize method to be called once per model container update.  
  if ( componentBase()->mixGenerator() )
  {
          const std::vector<Parameter*>& parameterSet = componentBase()->parameterSet();
          size_t  numParams = parameterSet.size();
          std::vector<Real>  startValues(numParams);
          for (size_t j = 0; j < numParams; ++j)
          {
                  startValues[j] = parameterSet[j]->value();
          }

          const string& modelName = parent()->parentName();
          componentBase()->mixGenerator()->initialize(startValues, modelName);
  }
  //## end MixComponent::initialize%3F9D5A6B02AD.body
}

void MixComponent::perform (const EnergyPointer& energy, GroupFluxContainer& flux, GroupFluxContainer& fluxError)
{
  //## begin MixComponent::perform%3F66204C0031.body preserve=yes
  
  // this perform method must pass information from the SumComponent to be massaged
  // by the implementation of the mixing model component.
        
  const XSModelFunction*  generator(componentBase()->generator());
  
  // parameterValues
  const std::vector<Parameter*>& parameterSet = componentBase()->parameterSet();
  size_t  numParams = parameterSet.size();
  std::vector<Real>  startValues(numParams);
  for (size_t j = 0; j < numParams; ++j)
  {
          startValues[j] = parameterSet[j]->value();
  }
  
  // The MixGenerator pointer is of type MixBase and passes an instance
  // of a model specific class implementation to the generator function.
  // this ensures persistence and memory management. The MixBase* object
  // must be constructed on first call and
  // will be deleted by the ComponentBase dtor.
  // If the model is not implemented in C++
  // the generator can ignore this ptr address.  But needs a different way
  // of ensuring persistence and memory management if those are appropriate.
  MixBase* mixGenPtr = componentBase()->mixGenerator();
  bool unInitialized (!mixGenPtr);
  std::auto_ptr<MixBase*>  pMixGeneratorHandle (new MixBase*(mixGenPtr));  
  MixBase** mixGeneratorHandle (pMixGeneratorHandle.get());
  const string& modelName = parent()->parentName();
  (*generator)(energy, startValues, flux, fluxError, mixGeneratorHandle, modelName);
  if ( unInitialized && *mixGeneratorHandle ) componentBase()->mixGenerator(*mixGeneratorHandle);
         
  //## end MixComponent::perform%3F66204C0031.body
}

void MixComponent::verifyData () const
{
  //## begin MixComponent::verifyData%3F9EEA8300AB.body preserve=yes
  if ( componentBase()->mixGenerator() ) componentBase()->mixGenerator()->verifyData();
  //## end MixComponent::verifyData%3F9EEA8300AB.body
}

void MixComponent::initializeForFit ()
{
  //## begin MixComponent::initializeForFit%3FA94F9C03E5.body preserve=yes
  // called once per fit and only for first data group.
  if (root()->dataGroupNumber() == 1)
  {
     if ( componentBase()->mixGenerator() )
     {
             const std::vector<Parameter*>& parameterSet = componentBase()->parameterSet();
             size_t  numParams = parameterSet.size();
             bool parametersAreFrozen = true;
             std::vector<Real>  startValues(numParams);
             for (size_t j = 0; j < numParams; ++j)
             {
                     startValues[j] = parameterSet[j]->value();
                     if (!parameterSet[j]->isFrozen())
                     {
                        parametersAreFrozen = false;
                     }
             }


             componentBase()->mixGenerator()->initializeForFit(startValues, 
                                   parametersAreFrozen);
     }
  }
  //## end MixComponent::initializeForFit%3FA94F9C03E5.body
}

// Additional Declarations
  //## begin MixComponent%362809DF00E6.declarations preserve=yes
  //## end MixComponent%362809DF00E6.declarations

//## begin module%3C62B2170294.epilog preserve=yes
//## end module%3C62B2170294.epilog
